## snakemake 6.15.1

=== debian/changelog ===
snakemake (6.15.1-2) unstable; urgency=medium

  * Timeout and retry an intermittently hanging autopkgtest.
  * Upload to unstable.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 04 Feb 2022 22:35:19 +0000

snakemake (6.15.1-1~exp1) experimental; urgency=medium

  * New upstream release.  Refresh patches, d/copyright.
  * Split up the binary package (main, -doc) to save space.
  * Tests: skip an FTP-using test and 2 new conda-using tests,
    mark as needs-internet, copy the test tree to avoid writing to it.
  * Don't ship the test suite, as some of it doesn't work from a
    non-writable directory.
  * Reproducibility: fix sphinx locale,
    skip a test that fails under faketime.
  * salsa-ci: ignore expected Lintian error, enable diffoscope.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 02 Feb 2022 07:36:20 +0000

=== debian/control ===
Source: snakemake
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <kdmfoss@gmail.com>, Rebecca N. Palmer <rebecca_palmer@zoho.com>
Section: science
Priority: optional
Build-Depends: ca-certificates,
               cwltool,
               debhelper-compat (= 13),
               dh-python,
               environment-modules,
               imagemagick,
               python3,
               python3-appdirs <!nocheck>,
               python3-biopython <!nocheck>,
               python3-boto3 <!nocheck>,
               python3-botocore <!nocheck>,
               python3-configargparse,
               python3-connection-pool,
               python3-datrie,
               python3-docutils,
               python3-dropbox <!nocheck>,
               python3-filelock,
               python3-flask <!nocheck>,
               python3-git,
               python3-jinja2,
               python3-jsonschema,
               python3-nbformat,
               python3-networkx <!nocheck>,
               python3-pandas <!nocheck>,
               python3-pkg-resources,
               python3-psutil,
               python3-pulp (>= 2.0~),
               python3-pygments <!nocheck>,
               python3-pygraphviz <!nocheck>,
               python3-pytest <!nocheck>,
# sometimes fails tests https://github.com/pytest-dev/pytest-xdist/issues/469 python3-pytest-xdist,
               python3-pytools <!nocheck>,
               python3-ratelimiter,
               python3-recommonmark <!nodoc>,
               python3-requests,
               python3-requests-mock <!nocheck>,
               python3-rpy2 <!nocheck>,
               python3-setuptools,
               python3-smart-open (>= 3.0~),
               python3-sphinx (>= 3.0~) <!nodoc>,
               python3-sphinx-argparse <!nodoc>,
               python3-sphinx-bootstrap-theme <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               python3-stopit,
               python3-tabulate,
               python3-toposort <!nocheck>,
               python3-wrapt,
               python3-yaml,
               r-cran-rmarkdown,
               stress <!nocheck>
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/snakemake
Vcs-Git: https://salsa.debian.org/med-team/snakemake.git
Homepage: https://snakemake.readthedocs.io/
Rules-Requires-Root: no

Package: snakemake
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         ca-certificates,
         python3-appdirs,
         python3-configargparse,
         python3-datrie,
         python3-docutils,
         python3-git,
         python3-jsonschema,
         python3-nbformat,
         python3-pkg-resources,
         python3-psutil,
         python3-pulp (>= 2.0~),
         python3-ratelimiter,
         python3-requests,
         python3-toposort,
         python3-wrapt,
         python3-yaml,
Recommends: cwltool,
            imagemagick,
            python3-tz,
            python3-yappi,
# for the reports feature
            python3-jinja2,
            python3-networkx,
            python3-pygments,
            python3-pygraphviz,
# for distributed / cloud setups or online data access
            python3-azure-storage,
            python3-biopython,
            python3-boto3,
            python3-botocore,
            python3-connection-pool,
            python3-drmaa,
            python3-dropbox,
            python3-flask,
            python3-ftputil,
            python3-irodsclient,
            python3-kubernetes,
            python3-urllib3
Suggests: snakemake-doc
Description: pythonic workflow management system
 Build systems like GNU Make are frequently used to create complicated
 workflows, e.g. in bioinformatics. This project aims to reduce the
 complexity of creating workflows by providing a clean and modern domain
 specific language (DSL) in Python style, together with a fast and
 comfortable execution environment.


Package: snakemake-doc
Architecture: all
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Recommends: snakemake
Breaks: snakemake (<< 6.14)
Replaces: snakemake (<< 6.14)
Section: doc
Description: documentation for pythonic workflow management system
 Build systems like GNU Make are frequently used to create complicated
 workflows, e.g. in bioinformatics. This project aims to reduce the
 complexity of creating workflows by providing a clean and modern domain
 specific language (DSL) in Python style, together with a fast and
 comfortable execution environment.
 .
 This package provides the Sphinx-generated documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export PYBUILD_NAME=snakemake
export PYBUILD_DESTDIR_python3=debian/snakemake
# copy the tests and run them from there to avoid having to clean up after them
export PYBUILD_BEFORE_TEST_python3=chmod +x {dir}/bin/snakemake; cp -r {dir}/bin {dir}/tests {build_dir}
export PYBUILD_AFTER_TEST_python3=rm -fr {build_dir}/bin {build_dir}/tests
export PYBUILD_TEST_ARGS=python{version} -m pytest -v {build_dir}/tests/test*.py -k 'not test_cwl and not test_cwl_singularity and not test_url_include and not test_wrapper and not test_issue1083 and not test_github_issue78 and not test_container and not test_singularity and not test_singularity_conda and not test_convert_to_cwl and not test_report and not test_report_zip and not test_archive and not test_jupyter_notebook and not test_conda and not test_upstream_conda and not test_conda_custom_prefix and not test_script and not test_issue635 and not test_issue1093 and not test_default_resources and not test_default_remote and not test_remote and not test_output_file_cache_remote and not test_tibanna and not test_module_complex and not test_module_complex2 and not test_module_with_script and not test_module_report and not test_modules_meta_wrapper and not test_tes and not test_deploy_script and not test_deploy_hashing and not test_ancient and not test_github_issue1062 and not test_symlink_time_handling and not test_env_modules'

# Skipped because they download executables (which is forbidden in Debian buildd and debci)
# Snakefile/snakemake-wrapper/CWL scripts: test_cwl, test_cwl_singularity, test_url_include, test_wrapper, test_module_with_script, test_module_report, test_module_complex(2), test_modules_meta_wrapper
# Docker images: test_issue1083, test_github_issue78, test_container, test_singularity, test_singularity_conda, test_cwl_singularity, test_convert_to_cwl, test_report, test_report_zip, test_module_complex(2)
# Conda packages: test_archive, test_jupyter_notebook, test_conda, test_upstream_conda, test_conda_custom_prefix, test_wrapper, test_script, test_issue635, test_issue1093, test_singularity_conda, test_report, test_report_zip, test_deploy_script, test_deploy_hashing
# Note that even if conda were added to Debian (ITP #926416), using it normally would still be downloading executables = forbidden
# Modification to run without conda was previously attempted on test_issue635 (succeeded) and test_issue1093 (failed as current bwa gives a different ordering), but is not in current use

# Skipped due to not-in-Debian dependencies
# python3-moto (RFP #777089): test_default_resources, test_default_remote, test_remote, test_output_file_cache_remote
# python3-tibanna: test_tibanna (possibly also specific to one cloud provider?)
# python3-tes: test_tes

# Skipped due to network use
# skipped in build, but run in autopkgtest: test_ancient
# skipped in both as it uses FTP and some autopkgtest environments are http-only: test_github_issue1062
# Tests marked @connected skip themselves if network access isn't available

# Skipped in build to let reproducibility tests pass (it fails under faketime, with what looks like the outer script but not the rules running under it), but run in autopkgtest: test_symlink_time_handling

# possibly an actual bug: test_env_modules
# test_pipes_fail is done outside the main run in autopkgtest because it sometimes hangs

export PATH:=$(shell pybuild --print build_dir --interpreter python3 --name $(PYBUILD_NAME))/bin:$(PATH)

# Force the use of python3's sphinx-build.
export SPHINXBUILD=/usr/share/sphinx/scripts/python3/sphinx-build

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

# LC_ALL is for reproducibility
execute_after_dh_auto_build:
	PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
	LC_ALL=C.UTF-8 LANGUAGE=C.UTF-8 python3 setup.py build_sphinx

execute_after_dh_installdocs:
	find debian -name '__pycache__' -o name '.gitignore' | xargs rm -rf

# the modules.sh is a workaround for #928826; putting it in PYBUILD_BEFORE_TEST_python3 doesn't work
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	. /etc/profile.d/modules.sh && PYBUILD_SYSTEM=custom dh_auto_test
endif

override_dh_auto_clean:
	dh_auto_clean
	find . -name '__pycache__' | xargs -r rm -r
	rm -rf .snakemake snakemake.egg-info

=== debian/tests/control ===
# minimal Depends smoke test
Test-Command: cp tests/test_bash/Snakefile $AUTOPKGTEST_TMP && cd $AUTOPKGTEST_TMP && snakemake --cores 1 && grep -e bash test.out
Depends: snakemake
Restrictions: allow-stderr

# upstream's tests
Tests: run-unit-test
Depends: snakemake,
         environment-modules,
         r-base-core,
         python3-connection-pool,
         python3-ftputil,
         python3-jinja2,
         python3-pandas,
         python3-pygraphviz,
         python3-pytest,
         python3-requests-mock,
         stress
Restrictions: allow-stderr, needs-internet

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/snakemake-$1.tar.gz/" \
  https://github.com/snakemake/snakemake/releases/latest .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## snakemake 6.15.5

=== debian/changelog ===
snakemake (6.15.5-1) unstable; urgency=medium

  * Upstream bugfix release.
  * Remove drmaa Recommends, as that package is broken (see #951704).
  * Tests: skip peppy tests (not in Debian), use Python 3 subprocesses.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 20 Feb 2022 14:53:05 +0000

=== debian/control ===
--- 
+++ 
@@ -94,7 +94,6 @@
             python3-boto3,
             python3-botocore,
             python3-connection-pool,
-            python3-drmaa,
             python3-dropbox,
             python3-flask,
             python3-ftputil,

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 # copy the tests and run them from there to avoid having to clean up after them
 export PYBUILD_BEFORE_TEST_python3=chmod +x {dir}/bin/snakemake; cp -r {dir}/bin {dir}/tests {build_dir}
 export PYBUILD_AFTER_TEST_python3=rm -fr {build_dir}/bin {build_dir}/tests
-export PYBUILD_TEST_ARGS=python{version} -m pytest -v {build_dir}/tests/test*.py -k 'not test_cwl and not test_cwl_singularity and not test_url_include and not test_wrapper and not test_issue1083 and not test_github_issue78 and not test_container and not test_singularity and not test_singularity_conda and not test_convert_to_cwl and not test_report and not test_report_zip and not test_archive and not test_jupyter_notebook and not test_conda and not test_upstream_conda and not test_conda_custom_prefix and not test_script and not test_issue635 and not test_issue1093 and not test_default_resources and not test_default_remote and not test_remote and not test_output_file_cache_remote and not test_tibanna and not test_module_complex and not test_module_complex2 and not test_module_with_script and not test_module_report and not test_modules_meta_wrapper and not test_tes and not test_deploy_script and not test_deploy_hashing and not test_ancient and not test_github_issue1062 and not test_symlink_time_handling and not test_env_modules'
+export PYBUILD_TEST_ARGS=python{version} -m pytest -v {build_dir}/tests/test*.py -k 'not test_cwl and not test_cwl_singularity and not test_url_include and not test_wrapper and not test_issue1083 and not test_github_issue78 and not test_container and not test_singularity and not test_singularity_conda and not test_convert_to_cwl and not test_report and not test_report_zip and not test_archive and not test_jupyter_notebook and not test_conda and not test_upstream_conda and not test_conda_custom_prefix and not test_script and not test_issue635 and not test_issue1093 and not test_default_resources and not test_default_remote and not test_remote and not test_output_file_cache_remote and not test_tibanna and not test_module_complex and not test_module_complex2 and not test_module_with_script and not test_module_report and not test_modules_meta_wrapper and not test_tes and not test_deploy_script and not test_deploy_hashing and not test_peppy and not test_modules_peppy and not test_ancient and not test_github_issue1062 and not test_symlink_time_handling and not test_env_modules'
 
 # Skipped because they download executables (which is forbidden in Debian buildd and debci)
 # Snakefile/snakemake-wrapper/CWL scripts: test_cwl, test_cwl_singularity, test_url_include, test_wrapper, test_module_with_script, test_module_report, test_module_complex(2), test_modules_meta_wrapper
@@ -19,6 +19,7 @@
 
 # Skipped due to not-in-Debian dependencies
 # python3-moto (RFP #777089): test_default_resources, test_default_remote, test_remote, test_output_file_cache_remote
+# python3-peppy: test_peppy, test_modules_peppy
 # python3-tibanna: test_tibanna (possibly also specific to one cloud provider?)
 # python3-tes: test_tes

## snakemake 7.8.3

=== debian/changelog ===
snakemake (7.8.3-1) unstable; urgency=medium

  * Team upload.

  [ Nilesh Patra]
  * New upstream version 7.8.3
  * Refresh/Rediff patches
  * Mark tests offline even on timeouterror
  * Embed retry python mod code and modify
    import path until python-retry is packaged
  * Remove yte dep for now

  [ Rebecca N. Palmer ]
  * New upstream release.  Refresh patches, d/copyright.
  * Skip some more unrunnable-in-Debian tests.
  * Update dependencies.
  * Update Lintian overrides.

 -- Nilesh Patra <nilesh@debian.org>  Sat, 25 Jun 2022 15:38:25 +0530

=== debian/control ===
--- 
+++ 
@@ -19,19 +19,16 @@
                python3-datrie,
                python3-docutils,
                python3-dropbox <!nocheck>,
-               python3-filelock,
                python3-flask <!nocheck>,
                python3-git,
-               python3-jinja2,
+               python3-jinja2 (>= 3.0~),
                python3-jsonschema,
                python3-nbformat,
-               python3-networkx <!nocheck>,
                python3-pandas <!nocheck>,
                python3-pkg-resources,
                python3-psutil,
                python3-pulp (>= 2.0~),
                python3-pygments <!nocheck>,
-               python3-pygraphviz <!nocheck>,
                python3-pytest <!nocheck>,
 # sometimes fails tests https://github.com/pytest-dev/pytest-xdist/issues/469 python3-pytest-xdist,
                python3-pytools <!nocheck>,
@@ -83,11 +80,10 @@
             imagemagick,
             python3-tz,
             python3-yappi,
-# for the reports feature
-            python3-jinja2,
-            python3-networkx,
+# for the templating and reports features
+            python3-jinja2 (>= 3.0~),
             python3-pygments,
-            python3-pygraphviz,
+# we don't have python3-yte (>= 1.0~)
 # for distributed / cloud setups or online data access
             python3-azure-storage,
             python3-biopython,
@@ -99,6 +95,7 @@
             python3-ftputil,
             python3-irodsclient,
             python3-kubernetes,
+# we don't have python3-retry, #961109
             python3-urllib3
 Suggests: snakemake-doc
 Description: pythonic workflow management system

=== debian/tests/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
 Tests: run-unit-test
 Depends: snakemake,
          environment-modules,
+         graphviz,
          r-base-core,
          python3-connection-pool,
          python3-ftputil,
-         python3-jinja2,
+         python3-jinja2 (>= 3.0~),
          python3-pandas,
-         python3-pygraphviz,
          python3-pytest,
          python3-requests-mock,
          stress

## snakemake 7.8.5

=== debian/changelog ===
snakemake (7.8.5-2) unstable; urgency=medium

  * Team upload.
  * Do not run second lot of tests on s390x

 -- Nilesh Patra <nilesh@debian.org>  Thu, 07 Jul 2022 15:49:32 +0530

snakemake (7.8.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 7.8.5
  * Refresh patches

 -- Nilesh Patra <nilesh@debian.org>  Tue, 05 Jul 2022 21:51:30 +0530

snakemake (7.8.3-2) unstable; urgency=medium

  * Team upload.
  * Propagate build time test ignores in autopkgtest as well
  * Add python3-pygments to test-deps

 -- Nilesh Patra <nilesh@debian.org>  Sat, 25 Jun 2022 20:53:15 +0530

=== debian/tests/control ===
--- 
+++ 
@@ -15,5 +15,7 @@
          python3-pandas,
          python3-pytest,
          python3-requests-mock,
+         python3-pygments,
          stress
 Restrictions: allow-stderr, needs-internet
+Architecture: !s390x

## snakemake 7.9.0

=== debian/changelog ===
snakemake (7.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Drop unnecessary dependency on build-essential.
  * Fix lintian syntax
  * Use Debian packaged bootstrap and jquery for privacy reasons
  * Add README.Debian to give a hint about potential issues inside
    the replaced jquery interface.
  * Build-Depends: pybuild-plugin-pyproject

 -- Andreas Tille <tille@debian.org>  Tue, 26 Jul 2022 12:10:25 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                cwltool,
                debhelper-compat (= 13),
                dh-python,
+               pybuild-plugin-pyproject,
                environment-modules,
                imagemagick,
                python3,
@@ -30,7 +31,6 @@
                python3-pulp (>= 2.0~),
                python3-pygments <!nocheck>,
                python3-pytest <!nocheck>,
-# sometimes fails tests https://github.com/pytest-dev/pytest-xdist/issues/469 python3-pytest-xdist,
                python3-pytools <!nocheck>,
                python3-ratelimiter,
                python3-recommonmark <!nodoc>,
@@ -50,7 +50,7 @@
                python3-yaml,
                r-cran-rmarkdown,
                stress <!nocheck>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/snakemake
 Vcs-Git: https://salsa.debian.org/med-team/snakemake.git
 Homepage: https://snakemake.readthedocs.io/
@@ -76,6 +76,8 @@
          python3-toposort,
          python3-wrapt,
          python3-yaml,
+         libjs-bootstrap,
+         libjs-jquery,
 Recommends: cwltool,
             imagemagick,
             python3-tz,

## snakemake 7.12.0

=== debian/changelog ===
snakemake (7.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 7.12.0
  * Refresh, re-diff patches
  * Add python3-pytest-mock to B-D and test dep
  * Update test_from_any_directory.patch

 -- Nilesh Patra <nilesh@debian.org>  Fri, 29 Jul 2022 19:23:21 +0530

## snakemake 7.12.1

=== debian/changelog ===
snakemake (7.12.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 24 Aug 2022 16:45:00 +0200

=== debian/control ===
--- 
+++ 
@@ -36,6 +36,7 @@
                python3-recommonmark <!nodoc>,
                python3-requests,
                python3-requests-mock <!nocheck>,
+               python3-pytest-mock <!nocheck>,
                python3-rpy2 <!nocheck>,
                python3-setuptools,
                python3-smart-open (>= 3.0~),

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export PYBUILD_NAME=snakemake
export PYBUILD_DESTDIR_python3=debian/snakemake
# copy the tests and run them from there to avoid having to clean up after them
export PYBUILD_BEFORE_TEST_python3=chmod +x {dir}/bin/snakemake; cp -r {dir}/bin {dir}/tests {build_dir}
export PYBUILD_AFTER_TEST_python3=rm -fr {build_dir}/bin {build_dir}/tests
export PYBUILD_TEST_ARGS=python{version} -m pytest -v {build_dir}/tests/test*.py -k 'not test_cwl and not test_cwl_singularity and not test_url_include and not test_wrapper and not test_issue1083 and not test_github_issue78 and not test_container and not test_singularity and not test_singularity_conda and not test_convert_to_cwl and not test_report and not test_report_zip and not test_archive and not test_jupyter_notebook and not test_conda and not test_upstream_conda and not test_conda_custom_prefix and not test_script and not test_issue635 and not test_issue1093 and not test_default_resources and not test_default_remote and not test_remote and not test_output_file_cache_remote and not test_tibanna and not test_module_complex and not test_module_complex2 and not test_module_with_script and not test_module_report and not test_modules_meta_wrapper and not test_tes and not test_deploy_script and not test_deploy_hashing and not test_peppy and not test_modules_peppy and not test_report_display_code and not test_wrapper_local_git_prefix and not test_template_engine and not test_github_issue1396 and not test_modules_prefix and not test_ancient and not test_github_issue1062 and not test_symlink_time_handling and not test_env_modules and not test_github_issue1460 and not test_rule_inheritance_globals'

# Skipped because they download executables (which is forbidden in Debian buildd and debci)
# Snakefile/snakemake-wrapper/CWL scripts: test_cwl, test_cwl_singularity, test_url_include, test_wrapper, test_wrapper_local_git_prefix, test_module_with_script, test_module_report, test_module_complex(2), test_modules_meta_wrapper
# Docker images: test_issue1083, test_github_issue78, test_container, test_singularity, test_singularity_conda, test_cwl_singularity, test_convert_to_cwl, test_report, test_report_zip, test_module_complex(2)
# Conda packages: test_archive, test_jupyter_notebook, test_conda, test_upstream_conda, test_conda_custom_prefix, test_wrapper, test_wrapper_local_git_prefix, test_script, test_issue635, test_issue1093, test_singularity_conda, test_report, test_report_zip, test_report_display_code, test_deploy_script, test_deploy_hashing
# Note that even if conda were added to Debian (ITP #926416), using it normally would still be downloading executables = forbidden
# Modification to run without conda was previously attempted on test_issue635 (succeeded) and test_issue1093 (failed as current bwa gives a different ordering), but is not in current use

# Skipped due to not-in-Debian dependencies
# python3-moto (RFP #777089): test_default_resources, test_default_remote, test_remote, test_output_file_cache_remote
# python3-retry: test_modules_prefix test_ancient
# python3-peppy: test_peppy, test_modules_peppy
# python3-tibanna: test_tibanna (possibly also specific to one cloud provider?)
# python3-tes: test_tes
# python3-yte: test_template_engine

# Skipped due to network use
# skipped in build, but run in autopkgtest: test_ancient
# skipped in both as it uses FTP and some autopkgtest environments are http-only: test_github_issue1062
# Tests marked @connected skip themselves if network access isn't available

# Skipped in build to let reproducibility tests pass (it fails under faketime, with what looks like the outer script but not the rules running under it), but run in autopkgtest: test_symlink_time_handling

# possibly an actual bug: test_env_modules
# should be marked google_credentials: test_github_issue1396
# test_pipes_fail is done outside the main run in autopkgtest because it sometimes hangs

export PATH:=$(shell pybuild --print build_dir --interpreter python3 --name $(PYBUILD_NAME))/bin:$(PATH)

# Force the use of python3's sphinx-build.
export SPHINXBUILD=/usr/share/sphinx/scripts/python3/sphinx-build

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

# LC_ALL is for reproducibility
execute_after_dh_auto_build:
	PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
	LC_ALL=C.UTF-8 LANGUAGE=C.UTF-8 python3 setup.py build_sphinx

execute_after_dh_installdocs:
	find debian -name '__pycache__' -o name '.gitignore' | xargs rm -rf
	# Attention: Upstream is using jquery 2.1.1 while the replacement below is using the packaged version 3.5.13 - no idea whether this might break anything
	for html in `find debian -name "*.html"` ; do \
	    sed -i \
		-e 's#https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/[^/]*/css/bootstrap.min.css#file:///usr/share/javascript/bootstrap/css/bootstrap.min.css#g' \
		-e 's#https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/[^/]*/js/bootstrap.min.js#file:///usr/share/javascript/bootstrap/js/bootstrap.min.js#g' \
		-e 's#https://cdnjs.cloudflare.com/ajax/libs/jquery/[^/]*/jquery.min.js#file:///usr/share/javascript/jquery/jquery.min.js#g' \
		    $${html} ; \
	done

# the modules.sh is a workaround for #928826; putting it in PYBUILD_BEFORE_TEST_python3 doesn't work
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	. /etc/profile.d/modules.sh && PYBUILD_SYSTEM=custom dh_auto_test
endif

override_dh_auto_clean:
	dh_auto_clean
	find . -name '__pycache__' | xargs -r rm -r
	rm -rf .snakemake snakemake.egg-info

=== debian/tests/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
          python3-pandas,
          python3-pytest,
          python3-requests-mock,
+         python3-pytest-mock,
          python3-pygments,
          stress
 Restrictions: allow-stderr, needs-internet

## snakemake 7.19.1

=== debian/changelog ===
snakemake (7.19.1-1) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Standards-Version: 4.6.2 (routine-update)
  * Skip slurm tests since slurm is not setup at build time
  * Suggests: slurm-client
  * Skip lint test that is known to fail
  * Skip workflow test that is known to fail

 -- Andreas Tille <tille@debian.org>  Wed, 11 Jan 2023 07:29:29 +0100

=== debian/control ===
--- 
+++ 
@@ -46,12 +46,13 @@
                python3-sphinx-rtd-theme <!nodoc>,
                python3-stopit,
                python3-tabulate,
+               python3-throttler <!nocheck>,
                python3-toposort <!nocheck>,
                python3-wrapt,
                python3-yaml,
                r-cran-rmarkdown,
                stress <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/snakemake
 Vcs-Git: https://salsa.debian.org/med-team/snakemake.git
 Homepage: https://snakemake.readthedocs.io/
@@ -100,7 +101,8 @@
             python3-kubernetes,
 # we don't have python3-retry, #961109
             python3-urllib3
-Suggests: snakemake-doc
+Suggests: slurm-client,
+          snakemake-doc
 Description: pythonic workflow management system
  Build systems like GNU Make are frequently used to create complicated
  workflows, e.g. in bioinformatics. This project aims to reduce the
@@ -118,6 +120,7 @@
 Breaks: snakemake (<< 6.14)
 Replaces: snakemake (<< 6.14)
 Section: doc
+Multi-Arch: foreign
 Description: documentation for pythonic workflow management system
  Build systems like GNU Make are frequently used to create complicated
  workflows, e.g. in bioinformatics. This project aims to reduce the

## snakemake 7.20.0

=== debian/changelog ===
snakemake (7.20.0-1) unstable; urgency=medium

  * New upstream release.  Refresh patches, d/copyright.
  * Use packaged python3-retry.
  * Don't try to use local Javascript in GUI, as this is risky.
    (Closes: #1019317)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 02 Feb 2023 07:28:24 +0000

## snakemake 7.21.0

=== debian/changelog ===
snakemake (7.21.0-1) unstable; urgency=medium

  * New upstream release.  Refresh patches.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 07 Feb 2023 21:19:40 +0000

=== debian/control ===
--- 
+++ 
@@ -36,6 +36,7 @@
                python3-recommonmark <!nodoc>,
                python3-requests,
                python3-requests-mock <!nocheck>,
+               python3-retry,
                python3-pytest-mock <!nocheck>,
                python3-rpy2 <!nocheck>,
                python3-setuptools,
@@ -99,7 +100,7 @@
             python3-ftputil,
             python3-irodsclient,
             python3-kubernetes,
-# we don't have python3-retry, #961109
+            python3-retry,
             python3-urllib3
 Suggests: slurm-client,
           snakemake-doc

=== debian/rules ===
--- 
+++ 
@@ -51,14 +51,6 @@
 
 execute_after_dh_installdocs:
 	find debian -name '__pycache__' -o name '.gitignore' | xargs rm -rf
-	# Attention: Upstream is using jquery 2.1.1 while the replacement below is using the packaged version 3.5.13 - no idea whether this might break anything
-	for html in `find debian -name "*.html"` ; do \
-	    sed -i \
-		-e 's#https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/[^/]*/css/bootstrap.min.css#file:///usr/share/javascript/bootstrap/css/bootstrap.min.css#g' \
-		-e 's#https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/[^/]*/js/bootstrap.min.js#file:///usr/share/javascript/bootstrap/js/bootstrap.min.js#g' \
-		-e 's#https://cdnjs.cloudflare.com/ajax/libs/jquery/[^/]*/jquery.min.js#file:///usr/share/javascript/jquery/jquery.min.js#g' \
-		    $${html} ; \
-	done
 
 # the modules.sh is a workaround for #928826; putting it in PYBUILD_BEFORE_TEST_python3 doesn't work
 override_dh_auto_test:

## snakemake 7.32.4

=== docs/requirements.txt ===
sphinx >=3
sphinxcontrib-napoleon
sphinx-argparse
sphinx_rtd_theme
docutils
myst-parser
configargparse
appdirs

=== tests/resources/slurmcluster/Makefile ===
# taken and modified from https://github.com/stevekm/slurm-cluster-vagrant

SHELL:=/bin/bash

# Create Vagrant VMs
# copy munge authenication key from slurmmaster to node
# !! need cp -p or else munge keys do not work
setup:
	vagrant up #&& \
	#vagrant up node-1 && \
	#vagrant up node-2 
	#vagrant ssh slurmmaster -- -t 'ssh-keygen -b 2048 -t rsa -q -N "" -f /home/vagrant/.ssh/id_rsa' && \
	#vagrant ssh slurmmaster -- -t 'cp /home/vagrant/.ssh/id_rsa.pub /vagrant/id_rsa.slurmmaster.pub' && \
	#vagrant ssh node-1 -- -t 'ssh-keygen -b 2048 -t rsa -q -N "" -f /home/vagrant/.ssh/id_rsa' && \
	#vagrant ssh node-1 -- -t 'cp /home/vagrant/.ssh/id_rsa.pub /vagrant/id_rsa.server.pub' && \
	#vagrant ssh node-2 -- -t 'ssh-keygen -b 2048 -t rsa -q -N "" -f /home/vagrant/.ssh/id_rsa' && \
	#vagrant ssh node-2 -- -t 'cp /home/vagrant/.ssh/id_rsa.pub /vagrant/id_rsa.server.pub' && \
	#vagrant ssh slurmmaster -- -t 'cat /vagrant/id_rsa.node-1.pub >> .ssh/authorized_keys' && \
	#vagrant ssh slurmmaster -- -t 'cat /vagrant/id_rsa.node-2.pub >> .ssh/authorized_keys' && \
	#rm -f  id_rsa.slurmmaster.pub id_rsa.server.pub

# make sure 'slurm' dir is writable for VMs
# start munge in both VMs
# start slurmctld, wait many seconds for it to fully start
# start slurmd
#start:
#	find slurm -type d -exec chmod a+rwx {} \; && \
#	vagrant ssh slurmmaster -- -t 'sudo /etc/init.d/munge start; sleep 5' && \
#	vagrant ssh node-1 -- -t 'sudo /etc/init.d/munge start; sleep 5' && \
#	vagrant ssh node-2 -- -t 'sudo /etc/init.d/munge start; sleep 5' && \
#	vagrant ssh slurmmaster -- -t 'sudo slurmctld; sleep 30' && \
#	vagrant ssh node-1 -- -t 'sudo slurmd; sleep 30' && \
#	vagrant ssh node-2 -- -t 'sudo slurmd; sleep 30' && \
#	vagrant ssh slurmmaster -- -t 'sudo scontrol update nodename=server state=resume; sinfo; sleep 5'
#
sinfo:
	vagrant ssh slurmmaster -- -t 'sinfo'

# might need this to fix node down state?
# fix:
# 	vagrant ssh slurmmaster -- -t 'sudo scontrol update nodename=server state=resume'

# https://slurm.schedmd.com/troubleshoot.html
# munge log: /var/log/munge/munged.log
test:
	@printf ">>> Checking munge keys on both machines\n"
	@vagrant ssh slurmmaster -- -t 'sudo md5sum /etc/munge/munge.key; ls -l /etc/munge/munge.key'
	@vagrant ssh server -- -t 'sudo md5sum /etc/munge/munge.key; ls -l /etc/munge/munge.key'
	@printf "\n\n>>> Checking if slurmmaster can contact node (network)\n"
	@vagrant ssh slurmmaster -- -t 'ping 10.10.10.4 -c1'
	@printf "\n\n>>> Checking if SLURM slurmmaster is running\n"
	@vagrant ssh slurmmaster -- -t 'scontrol ping'
	@printf "\n\n>>> Checking if slurmctld is running on slurmmaster\n"
	@vagrant ssh slurmmaster -- -t 'ps -el | grep slurmctld'
	@printf "\n\n>>> Checking cluster status\n"
	@vagrant ssh slurmmaster -- -t 'sinfo'
	@printf "\n\n>>> Checking if node can contact slurmmaster (network)\n"
	@vagrant ssh node-1 -- -t 'ping 10.10.10.3 -c1'
	@printf "\n\n>>> Checking if node can contact SLURM slurmmaster\n"
	@vagrant ssh node-1 -- -t 'scontrol ping'
	@printf "\n\n>>> Checking if slurmd is running on node\n"
	@vagrant ssh node-1 -- -t 'ps -el | grep slurmd'
	@printf "\n\n>>> Running a test job\n"
	@vagrant ssh slurmmaster -- -t 'sbatch --wrap="hostname"'
	@printf "\n\n>>> Running another test job\n"
	@vagrant ssh slurmmaster -- -t 'sbatch /vagrant/job.sh'
	@printf "\n\n>>> Checking node status\n"
	@vagrant ssh slurmmaster -- -t 'scontrol show nodes=server'

# pull the plug on the VMs
stop:
	vagrant halt --force slurmmaster
	vagrant halt --force node-1
	vagrant halt --force node-2

# delete the VMs
remove:
	vagrant destroy slurmmaster
	vagrant destroy node-1
	vagrant destroy node-2

# location of the SLURM default config generators for making new conf files
get-config-html:
	vagrant ssh slurmmaster -- -t 'cp /usr/share/doc/slurmctld/*.html /vagrant/'

# get rid of the SLURM log files
clean:
	find slurm -type f ! -name ".gitkeep" -exec rm -f {} \;

=== debian/changelog ===
snakemake (7.32.4-7) unstable; urgency=medium

  * Tests: treat more tests as flaky (try 3 times)
    (workaround for #1095394),
    use json not print for consistent formatting,
    use svg not pdf for compatibility with graphviz 12.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 09 Feb 2025 20:56:35 +0000

snakemake (7.32.4-6) unstable; urgency=medium

  * Stop using pkg_resources. (Closes: #1083775)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 04 Oct 2024 19:09:12 +0100

snakemake (7.32.4-5) unstable; urgency=medium

  * Tests: revert extra debug output.
  * Tests: make test_*_solver actually call the solver.
  * Tests: allow extra time to avoid failing on riscv64.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 07 Aug 2024 07:57:41 +0100

snakemake (7.32.4-4) unstable; urgency=medium

  * Skip tests that crash in persistent_dict because
    Debian's pytools is too old (workaround for #1076925).
  * Tests: add extra debug output to test_cluster_cancel*.
  * Bump Standards-Version to 4.7.0 (no changes needed).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 03 Aug 2024 13:49:07 +0100

snakemake (7.32.4-3) unstable; urgency=medium

  * Use platformdirs not appdirs.  (Closes: #1068010)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 07 Apr 2024 11:37:02 +0100

snakemake (7.32.4-2) unstable; urgency=medium

  * Tests: don't mix tabs and spaces, as Python 3.12 rejects this.
  * Adapt to f-strings being tokenized in Python 3.12.
    (together, Closes: #1061761)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 09 Feb 2024 19:11:23 +0000

snakemake (7.32.4-1) unstable; urgency=medium

  * New upstream release.  Update d/copyright and patches.
  * Skip newly added tests that we can't run.
  * Clean up after docs build.  (Closes: #1045316)
  * Depend on python3-yte.
  * Fix crash in config handling.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 27 Nov 2023 20:19:37 +0000

snakemake (7.21.0-2) unstable; urgency=medium

  * Add timeout to tests (giving a traceback when they hang).
  * Docs: allow building with Sphinx 7.  (Closes: #1042692)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 03 Aug 2023 22:24:25 +0100

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,10 @@
                dh-python,
                pybuild-plugin-pyproject,
                environment-modules,
+               glpk-utils <!nocheck>,
                imagemagick,
                python3,
-               python3-appdirs <!nocheck>,
+               python3-platformdirs <!nocheck>,
                python3-biopython <!nocheck>,
                python3-boto3 <!nocheck>,
                python3-botocore <!nocheck>,
@@ -25,8 +26,8 @@
                python3-jinja2 (>= 3.0~),
                python3-jsonschema,
                python3-nbformat,
+               python3-packaging,
                python3-pandas <!nocheck>,
-               python3-pkg-resources,
                python3-psutil,
                python3-pulp (>= 2.0~),
                python3-pygments <!nocheck>,
@@ -51,9 +52,10 @@
                python3-toposort <!nocheck>,
                python3-wrapt,
                python3-yaml,
+               python3-yte <!nocheck>,
                r-cran-rmarkdown,
                stress <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/snakemake
 Vcs-Git: https://salsa.debian.org/med-team/snakemake.git
 Homepage: https://snakemake.readthedocs.io/
@@ -64,14 +66,14 @@
 Depends: ${misc:Depends},
          ${python3:Depends},
          ca-certificates,
-         python3-appdirs,
+         python3-platformdirs,
          python3-configargparse,
          python3-datrie,
          python3-docutils,
          python3-git,
          python3-jsonschema,
          python3-nbformat,
-         python3-pkg-resources,
+         python3-packaging,
          python3-psutil,
          python3-pulp (>= 2.0~),
          python3-ratelimiter,
@@ -79,6 +81,7 @@
          python3-toposort,
          python3-wrapt,
          python3-yaml,
+         python3-yte,
          libjs-bootstrap,
          libjs-jquery,
 Recommends: cwltool,
@@ -88,7 +91,6 @@
 # for the templating and reports features
             python3-jinja2 (>= 3.0~),
             python3-pygments,
-# we don't have python3-yte (>= 1.0~)
 # for distributed / cloud setups or online data access
             python3-azure-storage,
             python3-biopython,

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export PYBUILD_NAME=snakemake
export PYBUILD_DESTDIR_python3=debian/snakemake
# copy the tests and run them from there to avoid having to clean up after them
export PYBUILD_BEFORE_TEST_python3=chmod +x {dir}/bin/snakemake; cp -r {dir}/bin {dir}/tests {build_dir}
export PYBUILD_AFTER_TEST_python3=rm -fr {build_dir}/bin {build_dir}/tests
export PYBUILD_TEST_ARGS=python{version} -m pytest -o faulthandler_timeout=60 -v {build_dir}/tests/test*.py -k 'not test_cwl and not test_cwl_singularity and not test_url_include and not test_wrapper and not test_issue1083 and not test_github_issue78 and not test_container and not test_singularity and not test_singularity_conda and not test_convert_to_cwl and not test_report and not test_report_zip and not test_archive and not test_jupyter_notebook and not test_conda and not test_upstream_conda and not test_conda_custom_prefix and not test_script and not test_issue635 and not test_issue1093 and not test_default_resources and not test_default_remote and not test_remote and not test_output_file_cache_remote and not test_tibanna and not test_module_complex and not test_module_complex2 and not test_module_with_script and not test_module_report and not test_modules_meta_wrapper and not test_tes and not test_deploy_script and not test_deploy_hashing and not test_peppy and not test_modules_peppy and not test_report_display_code and not test_wrapper_local_git_prefix and not test_github_issue1396 and not test_az_batch_executor and not test_modules_prefix and not test_ancient and not test_github_issue1062 and not test_symlink_time_handling and not test_env_modules and not test_github_issue1460 and not test_rule_inheritance_globals and not test_prebuilt_conda_script and not test_persistent_dict and not test_issue328 and not test_pipes_fail and not test_pipes and not test_multicomp_group_jobs and not test_group_job_resources_with_pipe'

# Skipped because they download executables (which is forbidden in Debian buildd and debci)
# Snakefile/snakemake-wrapper/CWL scripts: test_cwl, test_cwl_singularity, test_url_include, test_wrapper, test_wrapper_local_git_prefix, test_module_with_script, test_module_report, test_module_complex(2), test_modules_meta_wrapper
# Docker images: test_issue1083, test_github_issue78, test_container, test_singularity, test_singularity_conda, test_cwl_singularity, test_convert_to_cwl, test_report, test_report_zip, test_module_complex(2)
# Conda packages: test_archive, test_jupyter_notebook, test_conda, test_upstream_conda, test_conda_custom_prefix, test_wrapper, test_wrapper_local_git_prefix, test_script, test_issue635, test_issue1093, test_singularity_conda, test_report, test_report_zip, test_report_display_code, test_deploy_script, test_deploy_hashing
# Note that even if conda were added to Debian (ITP #926416), using it normally would still be downloading executables = forbidden
# Modification to run without conda was previously attempted on test_issue635 (succeeded) and test_issue1093 (failed as current bwa gives a different ordering), but is not in current use

# Skipped due to not-in-Debian dependencies
# conda (but not downloading): test_prebuilt_conda_script
# python3-moto (RFP #777089): test_default_resources, test_default_remote, test_remote, test_output_file_cache_remote
# python3-retry: test_modules_prefix test_ancient
# python3-peppy: test_peppy, test_modules_peppy
# python3-tibanna: test_tibanna (possibly also specific to one cloud provider?)
# python3-tes: test_tes

# Skipped due to network use
# skipped in build, but run in autopkgtest: test_ancient
# skipped in both as it uses FTP and some autopkgtest environments are http-only: test_github_issue1062
# Tests marked @connected skip themselves if network access isn't available

# Skipped in build to let reproducibility tests pass (it fails under faketime, with what looks like the outer script but not the rules running under it), but run in autopkgtest: test_symlink_time_handling

# possibly an actual bug: test_env_modules
# pytools too old, #1076925, only fail in build and not autopkgtest: test_persistent_dict test_issue328
# should be marked google_credentials: test_github_issue1396
# needs Azure credentials: test_az_batch_executor
# flaky (these are run in autopkgtest but get 3 tries there) test_pipes_fail, test_pipes, test_multicomp_group_jobs, test_group_job_resources_with_pipe

export PATH:=$(shell pybuild --print build_dir --interpreter python3 --name $(PYBUILD_NAME))/bin:$(PATH)

# Force the use of python3's sphinx-build.
export SPHINXBUILD=/usr/share/sphinx/scripts/python3/sphinx-build

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

# LC_ALL is for reproducibility
execute_after_dh_auto_build:
	PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
	cd docs && LC_ALL=C.UTF-8 LANGUAGE=C.UTF-8 make html

execute_after_dh_installdocs:
	find debian -name '__pycache__' -o name '.gitignore' | xargs rm -rf

# the modules.sh is a workaround for #928826; putting it in PYBUILD_BEFORE_TEST_python3 doesn't work
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	. /etc/profile.d/modules.sh && PYBUILD_SYSTEM=custom dh_auto_test
endif

override_dh_auto_clean:
	dh_auto_clean
	find . -name '__pycache__' | xargs -r rm -r
	rm -rf .snakemake snakemake.egg-info

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/snakemake-$1.tar.gz/" \
  https://github.com/snakemake/snakemake/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
